## blis 2.0

=== debian/changelog ===
blis (2.0-1) unstable; urgency=medium

  * Refresh symbols control file for i386 and generic architecture.
  * Release to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 20 Feb 2026 17:01:56 -0800

blis (2.0-1~exp1) experimental; urgency=medium

  * New upstream version 2.0
  * Rebase existing patches and remote those merged in new release.
  * Refresh symbols control file for arm64, amd64.
  * Remove kfreebsd-amd64 architecture.

 -- Mo Zhou <lumin@debian.org>  Thu, 19 Feb 2026 17:07:53 -0800
